<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isNew"
    @submit="onSubmitHandler"
    :dropdown-menu="dropdownMenu"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          :label="dictionaryRu.modal.name"
          v-model="formData.name"
          :disabled="!isNew"
          property="name"
          :placeholder="dictionaryRu.modal.name_placeholder"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          :label="dictionaryRu.modal.document_class"
          v-model="formData.document_class"
          :items="DOCUMENT_CLASS"
          :disabled="!isNew"
          display-exp="text"
          value-exp="value"
          property="document_class"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import FormValidationMixin   from 'common-components/src/obComponents/obForm/FormValidationMixin';
import models                from '@/models';
import cloneDeep             from 'clone-deep';
import DOCUMENT_CLASS_MIXIN  from '@/mixins/enum/document-class';
import ObInput               from 'common-components/src/obComponents/obInput';
import ObForm                from 'common-components/src/obComponents/obForm';
import ObSelect              from 'common-components/src/obComponents/obSelect';
import dropdownEvents        from '@/mixins/dictionaries/dropdown-events';
import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/dictionaries__services__document_types'

export default {
  name: 'DocumentType',
  components: {
    ObSelect,
    ObInput,
    ObForm
  },
  mixins: [
    FormValidationMixin,
    DOCUMENT_CLASS_MIXIN,
    dropdownEvents
  ],
  props: {
    disabledForm: {
      type: Boolean,
      default: true
    },
    dataSource: {
      type: Object,
      required: true,
      default: () => {}
    }
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    }
  },
  computed: {
    formModel() {
      return models.documentType.add;
    },
    isNew() {
      return !this.formData.uuid;
    }
  },
  methods: {
    onSubmitHandler() {
      const data = cloneDeep(this.formData);

      this.$emit('submit', { formData: data, model: this.formModel });
    }
  }
};
</script>

<style scoped>
</style>
